--レミリア・スカーレット用ai
--しなうす式/20220710check

require("function_pun_strage.lua")
head_req_list()

function main()
--シード生成、スレッド生成、base_states設定
	set_seedthreadstates()
--キャラ確認
	char_calling()
--ステージが 核融合炉心部 だと超反応モードに
	set_printsabot()

while true do
--スレッド外初期化
	while_top()

--●どちらかが体力無くなったら待機
	if interbattle_condi()==true then
		interbattle_exe()
--▼開幕行動▼
	elseif kaimaku_condi()==true then
		kaimaku_exe()
--▼移動起き上がり
	elseif my_act==97 or my_act==98 then --基本：画面端より遠ざかる。中央では相手から遠ざか…りたいが、設置技警戒のため、相手側に移動起き上がり。
		movedgetup_exe()

--▼簡易受け身▼：攻撃ないし回避いずれの目的であってもリカバリーポイントは限られるが、そういうことはさておき実装したもの
	elseif recovery_condi()==true then
		recovery_exe()

--▼台風になった時、フラグに従って「緋想の剣」を使用
	elseif y==0 and my_act<=10 and card_check(14) and flag_kishitu==1 then
		print("天候フラグＯＮ　⇒　「緋想の剣」使用");
		card_use(14);

--▼台風▼：近接状態からの強引な状況変更を行う行動。スペカなど使用。
	elseif react_rejecttaihu_condi()==true then
		react_rejecttaihu_exe()

--▼起き攻め▼
	elseif setplay_ongetup_condi()==true then
		setplay_ongetup_exe()
--▼ＨＪＣ▼
	--地上HJC
	elseif hjc_ground_condi()==true then
		hjc_ground_exe()
	--空中HJC
	elseif hjc_air_condi()==true then
		hjc_air_exe()

--▼反応行動
--反応：下段
	elseif 	react_lowattack_condi()==true then
		react_lowattack_exe()
--反応：地対空
	elseif react_g2a_condi()==true then
		react_g2a_exe()
--反応：低空飛翔
	elseif react_lowj6d_condi()==true then
		react_lowj6d_exe()
--上空追いかけ
	elseif ueoikake_condi()==true then
		ueoikake_exe()
--霊撃 or 霊撃札
	elseif reigeki_condi()==true then 
		print("拒否行動：霊撃　⇒　可能ならば使用");
		card_use(0)
		
--▼グレイズ：相手行動に対する反射or一定距離内のオブジェクト感知▼
--モーション反応グレイズ
	elseif
	graze_condition_xrange()==true and
	state_nottrueguard()==true and 
	my_airEX>=1 and 
	my_rei>=0 
	then--近距離時のグレイズ。のさばらせておくと、誤結界の原因となる。ガードの硬直間際ならok
		print("check 1 -> graze act X Range");
		graze_action_xrange()
			
--▼ ガード行動：簡易ガードルーチン▼
--▼ ガード反撃、龍魚の羽衣 13
	elseif hagoromo_1st_condi()==true or hagoromo_condi()==true then
		hagoromo_exe()

--回避結界
	elseif kekkai_condi()==true then
		kekkai_exe()

--▼ 宵越しの銭 12
	elseif yoikoshi_1st_condi()==true or yoikoshi_condi()==true then
		yoikoshi_exe()

--▼汎用中下段ガード
--基本は行動に対して後退入れ込み。下段のみ抽出して反応。通常射撃も同じく下段で受ける(けどメンドウだから今回は省き)。フラグを抜けてくるものは別個に対応
	elseif lowattack_aflags_condi()==true then
		guard_backexpectlowattack_exe()
	elseif overheadattack_aflags_condi()==true then
		guard_backoverheadattack_exe()
--下段判定をフィルタ
	elseif lowattack_flaged_condi()==true then
		guard_backexpectlowattack_exe()
--フラグを抜けてくるものをフィルタ
	elseif lowattack_unflaged_condi()==true then
		guard_backexpectlowattack_exe()
--屈状態では低空昇り攻撃には立てない
	elseif notstand_overhead_upjump_condi()==true then
		guard_backexpectlowattack_exe()
--以下、何もフィルタされなかった場合、立ちガード
	elseif guard_pun_condi()==true then
		guard_backoverheadattack_exe()

--[[▼オブジェが至近距離の場合、着地直前にｈｊを仕込む、タッチ＆ゴーグレイズ
	elseif touchandgo_00_condi() then
		touchandgo_00_exe()
--オブジェが至近距離の場合、ガードの前に、離陸
	elseif touchandgo_01_condi() then
		touchandgo_01_exe()
	elseif touchandgo_02_condi() then
		touchandgo_02_exe()
--]]
--オブジェが至近距離の場合、空中から地上へ飛翔　※咲夜：２D：120.0以上、３D：84.9以上必要
	elseif graze_pun_condi()==true then
		graze_pun_exe()
		
--遠距離時のグレイズ
	elseif graze_farground_condi() then
		graze_farground_exe()
	elseif graze_farair_condi() then
		graze_farair_exe()
		
--特定状況におけるガード
	elseif guard_objgimmick_condi()==true then
		guard_backexpectlowattack_exe()
--オブジェが至近距離の場合、ガード:射撃と打撃を重ねられると、しゃがみガードしてしまう。優先順位の変更が必要
	elseif guard_objclosedis_condi()==true then
		guard_backexpectlowattack_exe()
	
--▼起き上がり直後の行動
	elseif move_soonaftergetup_condi()==true then
		move_soonaftergetup_exe()

--▼コンボ▼

--AAAAコンボ
	elseif my_act==300 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and ((enemy_act>=50 and enemy_act<=89 or enemy_act==143) or (enemy_act>=145 and enemy_act<=166 and math.random(2)<=1)) then
		print("AA");
		key_event(ACT_A);
		elseif ey==0 and my_act==320 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and ((enemy_act>=50 and enemy_act<=89 or enemy_act==143) or (enemy_act>=145 and enemy_act<=166 and math.random(2)<=1)) then
			print("AAA");
			key_event(ACT_A);
			elseif ey==0 and my_act==321 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and ((enemy_act>=50 and enemy_act<=89 or enemy_act==143) or (enemy_act>=145 and enemy_act<=166 and math.random(2)<=1)) then
				print("AAAA");
				key_event(ACT_A);
				
--遠A>6A
	elseif my_act==301 and enemy_act>=50 and enemy_act<=166 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and math.random(2)==1 then
		print("遠Ａ＞６Ａ");
		key_event2(ACT_A,front);
		
--▼固め▼

--J5A>J5AA

	elseif my_act==306 and enemy_act>=50 and enemy_act<=166 and my_hitstop<=3 and my_hitstop>=1 then
		key_reset()
		print("J5A>J5AA");
		key_event(ACT_A);

--▼攻撃▼

--▼spell card▼

--▼cost2

--必殺「ハートブレイク」
	--Ground
	elseif card_check(201)==true and
		my_spell_more(1000) and
		dis<400 and
		y==0 and
		ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("必殺「ハートブレイク」");
			for i=1,10 do
				card_use(201);
				yield()
			end

--夜符「デーモンキングクレイドル」
	--Ground
	elseif card_check(202)==true and
		my_spell_more(1000) and
		dis<200 and
		y==0 and
		ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("夜符「デーモンキングクレイドル」");
			for i=1,10 do
				card_use(202);
				yield()
			end

--▼cost3

--紅符「不夜城レッド」
	--Ground
	elseif card_check(200)==true and
		my_spell_more(1500) and
		dis<200 and
		y==0 and
		ey<200 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("紅符「不夜城レッド」");
			for i=1,10 do
				card_use(200);
				yield()
			end

--夜符「バッドレディスクランブル」
	--Ground
	elseif card_check(206)==true and
		my_spell_more(1500) and
		dis<600 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("夜符「バッドレディスクランブル」");
			for i=1,10 do
				card_use(206);
				yield()
			end
	--Air
	elseif card_check(206)==true and
		my_spell_more(1500) and
		dis<600 and
		y>0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("夜符「バッドレディスクランブル」");
			for i=1,10 do
				card_use(206);
				yield()
			end

--運命「ミゼラブルフェイト」
	--Ground
	elseif card_check(207)==true and
		my_spell_more(1500) and
		dis2>600 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("運命「ミゼラブルフェイト」");
			for i=1,10 do
				card_use(207);
				yield()
			end

--▼cost4

--神槍「スピア・ザ・グングニル」
	--Ground
	elseif card_check(204)==true and
		my_spell_more(2000) and
		dis<600 and
		y==0 and
		ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("神槍「スピア・ザ・グングニル」");
			for i=1,10 do
				card_use(204);
				yield()
			end

--「ミレニアムの吸血鬼」
	--Ground
	elseif card_check(208)==true and
		my_spell_more(2000) and
		--dis<200 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("「ミレニアムの吸血鬼」");
			for i=1,10 do
				card_use(208);
				yield()
			end

--悪魔「レミリアストレッチ」
	--Ground
	elseif card_check(209)==true and
		my_spell_more(2000) and
		dis<300 and
		y==0 and
		ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("悪魔「レミリアストレッチ」");
			for i=1,10 do
				card_use(209);
				yield()
			end

--▼cost5

--紅魔「スカーレットデビル」
	--Ground
	elseif card_check(203)==true and
		my_spell_more(2500) and
		dis<200 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("紅魔「スカーレットデビル」");
			for i=1,10 do
				card_use(203);
				yield()
			end

--夜王「ドラキュラクレイドル」
	--Ground
	elseif card_check(205)==true and
		my_spell_more(2500) and
		dis<200 and
		y==0 and
		ey<100 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("夜王「ドラキュラクレイドル」");
			for i=1,10 do
				card_use(205);
				yield()
			end

--[[
--▼skill card▼

--▼スキル236

--デーモンロードウォーク100
	elseif get_skill_lv(0,0)>=0 and
		my_rei>=400 and
		dis<250 and
		y==0 and
		ey<=50 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("デーモンロードウォーク");
			lvr236(ACT_B);
			
	elseif get_skill_lv(0,0)>=0 and
		my_rei>=400 and 
		dis<500 and
		y==0 and
		ey<=50 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("デーモンロードウォーク");
			lvr236(ACT_C);

	elseif card_check(100)==true and
		my_rei>=400 and
		dis<250 and
		y==0 and
		ey<=50 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("デーモンロードウォーク");
			for i=1,10 do
				card_use(100);
				yield()
			end
			
--ヴァンパイアクロウ104
	elseif get_skill_lv(0,4)>=0 and
		my_rei>=400 and 
		dis<250 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("ヴァンパイアクロウ");
			lvr236(ACT_B);
			
	elseif get_skill_lv(0,4)>=0 and
		my_rei>=400 and 
		dis<250 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("ヴァンパイアクロウ");
			lvr236(ACT_C);

	elseif card_check(104)==true and
		my_rei>=400 and
		dis<250 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("ヴァンパイアクロウ");
			for i=1,10 do
				card_use(104);
				yield()
			end
			
--トリックスターデビル108
	elseif get_skill_lv(0,8)>=0 and
		my_rei>=400 and 
		dis<200 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("トリックスターデビル");
			lvr236(ACT_B);
			
	elseif get_skill_lv(0,8)>=0 and
		my_rei>=400 and 
		dis<400 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("トリックスターデビル");
			lvr236(ACT_C);

	elseif card_check(108)==true and
		my_rei>=400 and
		dis<200 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("トリックスターデビル");
			for i=1,10 do
				card_use(108);
				yield()
			end

--▼スキル623

--デーモンロードクレイドル102
	elseif get_skill_lv(0,2)>=0 and
		my_rei>=400 and 
		dis<200 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("デーモンロードクレイドル");
			lvr623(ACT_B);
			
	elseif get_skill_lv(0,2)>=0 and
		my_rei>=400 and 
		dis<200 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("デーモンロードクレイドル");
			lvr623(ACT_C);

	elseif card_check(102)==true and
		my_rei>=400 and
		dis<200 and
		y==0 and
		ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("デーモンロードクレイドル");
			for i=1,10 do
				card_use(102);
				yield()
			end
			
--ロケットキックアップ106
	elseif get_skill_lv(0,6)>=0 and
		my_rei>=400 and 
		ey-y>(ex-x) and ey-y<2*(ex-x) and
		--dis<200 and
		y==0 and
		--ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("ロケットキックアップ");
			lvr623(ACT_B);
			
	elseif get_skill_lv(0,6)>=0 and
		my_rei>=400 and 
		ey-y>(ex-x) and ey-y<2*(ex-x) and
		--dis<200 and
		y==0 and
		--ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("ロケットキックアップ");
			lvr623(ACT_C);

	elseif card_check(106)==true and
		my_rei>=400 and
		ey-y>(ex-x) and ey-y<2*(ex-x) and
		--dis<200 and
		y==0 and
		--ey<=150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("ロケットキックアップ");
			for i=1,10 do
				card_use(106);
				yield()
			end
			
--バンパイアキス110
	elseif get_skill_lv(0,10)>=0 and
		my_rei>=400 and 
		dis<200 and
		y==0 and
		ey==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("バンパイアキス");
			lvr623(ACT_B);
			
	elseif get_skill_lv(0,10)>=0 and
		my_rei>=400 and 
		dis<1200 and
		y==0 and
		ey==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("バンパイアキス");
			lvr623(ACT_C);

	elseif card_check(110)==true and
		my_rei>=400 and
		dis<200 and
		y==0 and
		ey==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("バンパイアキス");
			for i=1,10 do
				card_use(110);
				yield()
			end

--▼スキル22

--デーモンロードアロー103
	elseif get_skill_lv(0,3)>=0 and 
		my_rei>=400 and 
		--dis<100 and
		--y==0 and
		--ey==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(1280)==1 then
			print("デーモンロードアロー");
			lvr22(ACT_B);
			
	elseif get_skill_lv(0,3)>=0 and 
		my_rei>=400 and 
		--dis<100 and
		--y==0 and
		--ey==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(1280)==1 then
			print("デーモンロードアロー");
			lvr22(ACT_C);

	elseif card_check(103)==true and 
		my_rei>=400 and 
		--dis<100 and
		--y==0 and
		--ey==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("デーモンロードアロー");
			for i=1,10 do
				card_use(103);
				yield()
			end

--シーリングフィア107
	elseif get_skill_lv(0,7)>=0 and
		my_rei>=400 and 
		dis>350 and dis<450 and
		--y==0 and
		--ey<300 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("シーリングフィア");
			lvr22(ACT_B);
			
	elseif get_skill_lv(0,7)>=0 and
		my_rei>=400 and 
		dis>600 and dis<700 and
		--y==0 and
		--ey<300 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("シーリングフィア");
			lvr22(ACT_C);

	elseif card_check(107)==true and
		my_rei>=400 and
		dis>350 and dis<450 and
		--y==0 and
		--ey<300 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("シーリングフィア");
			for i=1,10 do
				card_use(107);
				yield()
			end

--スティグマナイザー111
	elseif get_skill_lv(0,11)>=0 and
		my_rei>=400 and 
		dis>200 and dis<400 and
		y==0 and
		ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("スティグマナイザー");
			lvr22(ACT_B);
			
	elseif get_skill_lv(0,11)>=0 and
		my_rei>=400 and 
		dis>400 and dis<600 and
		y==0 and
		ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("スティグマナイザー");
			lvr22(ACT_C);

	elseif card_check(111)==true and
		my_rei>=400 and 
		dis>200 and dis<400 and
		y==0 and
		ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("スティグマナイザー");
			for i=1,10 do
				card_use(111);
				yield()
			end

--▼スキル214

--サーヴァントフライヤー101
	elseif get_skill_lv(0,1)>=0 and
		my_rei>=400 and 
		dis>300 and
		y==0 and
		--ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("サーヴァントフライヤー");
			lvr214(ACT_B);
			
	elseif get_skill_lv(0,1)>=0 and
		my_rei>=400 and 
		dis>300 and
		y==0 and
		--ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("サーヴァントフライヤー");
			lvr214(ACT_C);

	elseif card_check(101)==true and
		my_rei>=400 and 
		dis>300 and
		y==0 and
		--ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("サーヴァントフライヤー");
			for i=1,10 do
				card_use(101);
				yield()
			end

--チェーンギャング105
	elseif get_skill_lv(0,5)>=0 and
		my_rei>=400 and 
		dis2>200 and
		y==0 and
		ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("チェーンギャング");
			lvr214(ACT_B);
			
	elseif get_skill_lv(0,5)>=0 and
		my_rei>=400 and 
		dis2>200 and
		y==0 and
		ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("チェーンギャング");
			lvr214(ACT_C);

	elseif card_check(105)==true and
		my_rei>=400 and 
		dis2>200 and
		y==0 and
		ey<150 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("チェーンギャング");
			for i=1,10 do
				card_use(105);
				yield()
			end

--デモンズディナーフォーク109
	elseif get_skill_lv(0,9)>=0 and
		my_rei>=400 and
		ey-y>0.5*(ex-x) and ey-y<1.5*(ex-x) and 
		dis>200 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("デモンズディナーフォーク");
			lvr214(ACT_B);
			
	elseif get_skill_lv(0,9)>=0 and
		my_rei>=400 and
		ey-y>0.5*(ex-x) and ey-y<1.5*(ex-x) and 
		dis>200 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("デモンズディナーフォーク");
			lvr214(ACT_C);

	elseif card_check(109)==true and
		my_rei>=400 and
		ey-y>0.5*(ex-x) and ey-y<1.5*(ex-x) and 
		dis>200 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("デモンズディナーフォーク");
			for i=1,10 do
				card_use(109);
				yield()
			end
--]]
--▼空中打撃▼

--J5A:25-100x,50-190y,9-10f
	elseif	y>0 and 
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(2)==1 and
	(y+my_yspeed*9+(9*(8*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*8		<=	100+20 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*8		>=	25-20 	and
				(ey+enemy_yspeed*9+(9*(8*e_gs))/2)	-	(y+my_yspeed*9+(9*(8*m_gs))/2)	<=	190-40 		and --自ヒットボックスの上端を、相手ヒットボックスの下端に当てた高さ
				(ey+enemy_yspeed*9+(9*(8*e_gs))/2)	-	(y+my_yspeed*9+(9*(8*m_gs))/2)	>=	50-160 	then  --自ヒットボックスの下端を、相手ヒットボックスの上端に当てた高さ
					print("J5A");
					key_event(ACT_A);
--
--[[J6A
	elseif	y>0 and 
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
	(y+my_yspeed*16+(16*(15*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*16		<=	270+20 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*16		>=	60-20 	and
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)	-	(y+my_yspeed*16+(16*(15*m_gs))/2)	<=	140-40	and
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)	-	(y+my_yspeed*16+(16*(15*m_gs))/2)	>=	60-160 	then
					print("J6A");
					key_event2(ACT_A,front); --]]
--
--J2A:-10+90x,-40+110y,11-12f
	elseif	y>0 and 
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(2)==1 and
	(y+my_yspeed*12+(12*(11*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*12		<=	90+20 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*12		>=	-10-20 	and
				(ey+enemy_yspeed*12+(12*(11*e_gs))/2)	-	(y+my_yspeed*12+(12*(11*m_gs))/2)	<=	110-40 		and
				(ey+enemy_yspeed*12+(12*(11*e_gs))/2)	-	(y+my_yspeed*12+(12*(11*m_gs))/2)	>=	-40-160 	then
					print("J2A");
					key_event2(ACT_A,ACT_DOWN);
--
--[[J8A:
	elseif	y>0 and 
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
	(y+my_yspeed*11+(11*(10*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX*11+2*2+enemy_xspeedEX*13)*1		<=	120+20 	and
				(ex-x)*my_dir-(my_xspeedEX*11+2*2+enemy_xspeedEX*13)*1		>=	-60-20 	and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	(y+my_yspeed*11+(11*(10*m_gs))/2)+15*2	<=	290-40		and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	(y+my_yspeed*11+(11*(10*m_gs))/2)+15*2	>=	95-160 	then
					print("J8A");
					key_event2(ACT_A,ACT_UP); --]]

--▼対空行動

--対空9HJ>J5A:15F:25-100x,50-190y,9-10f
--j/hj攻撃不能時間:6f
	elseif y==0 and 
	(ey>0 or --空中か
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162)) --諏訪子以外の立ち状態か
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166)) --諏訪子のしゃがみ状態
			)
		)
	) and 
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir	-	(15*10+enemy_xspeedEX*16)		<=	100+20 	and --自機のhj時におけるx軸速度*発生
				(ex-x)*my_dir	-	(15*10+enemy_xspeedEX*16)		>=	25-20 	and
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)	-	(y+17*10+(10*(9*-0.75))/2)	<=	190-40 		and --自機のhj時におけるy軸速度*発生(hj時の落下加速度を17としている)
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)	-	(y+17*10+(10*(9*-0.75))/2)	>=	50-160 	then --hj時の落下加速度を-0.75としている
					print("AA:9HJ>J5A");
					key_event2(ACT_D,u_front)
					wait(3)
					key_event(ACT_A);
					wait(3)
					
--対空8HJ>J5A:15F:25-100x,50-190y,9-10f
	elseif y==0 and 
	(ey>0 or --空中か
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162)) --諏訪子以外の立ち状態か
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166)) --諏訪子のしゃがみ状態
			)
		)
	) and 
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir	-	(enemy_xspeedEX*16)		<=	100+20 	and --自機のhj時におけるx軸速度*発生
				(ex-x)*my_dir	-	(enemy_xspeedEX*16)		>=	25-20 	and
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)	-	(y+20*10+(10*(9*-0.75))/2)	<=	190-40 		and --自機のhj時におけるy軸速度*発生(hj時のy軸速度を20としている)
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)	-	(y+20*10+(10*(9*-0.75))/2)	>=	50-160 	then --hj時の落下加速度を-0.75としている
					print("AA:9HJ>J5A");
					key_event2(ACT_D,u_front)
					wait(3)
					key_event(ACT_A);
					wait(3)
					
--対空2A:40-180x,40-170y,10-12f
	elseif	y==0 and 
	--dis<120 and
	ey>0 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir	-	(enemy_xspeedEX*10)				<=	180+20 	and
				(ex-x)*my_dir	-	(enemy_xspeedEX*10)				>=	40-20 	and
				(ey+enemy_yspeed*10+(10*(9*e_gs))/2)			<=	170-40 		and
				(ey+enemy_yspeed*10+(10*(9*e_gs))/2)			>=	40-160 	then
					print("AA:2A");
					key_event2(ACT_A,ACT_DOWN);
--]]		
--▼刻み▼
		
--[[刻み2Ａ
	elseif (dis<=120 or (dis<=150 and my_xspeed>0)) and 
	my_act==303 and ey==0 and 
	my_hitstop<=3 and my_hitstop>=2 and 
	enemy_obj_range_in(150,60)==false and 
	(
		(enemy_act>=50 and enemy_act<=89 and math.random(1)<=1) or
		(enemy_act>=143 and enemy_act<=166 and math.random(3)<=2)
	) and 
	subs_count>=530 and nega_count ~= 1 then
		print("刻み2Ａ");
		key_event2(ACT_A,ACT_DOWN);
		wait(5);  --]]
--
--▼通常技/Arts▼
					
--Ａ
	elseif y==0 and dis<=180-20 and ey<100 and 
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("A");
		key_event(ACT_A);
--▼機動▼
--6D>J5A>J5AA
	elseif dis<250 and dis>0 and y==0 and 
	my_act<=10 and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(32)==1 then
		print("6D");
		key_event2(ACT_D,front);
		wait(10)
		key_event(ACT_A)
--9hj
	elseif dis<1280 and dis>300 and y==0 and my_act<=10 and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(32)==1 then
		print("9hj");
		key_event2(ACT_D,u_front);
--7hj
	elseif dis<1280 and dis>0 and y==0 and my_act<=10 and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(128)==1 then
		print("7hj");
		key_event2(ACT_D,u_back);
--7hj>9D>J2Ch
	elseif dis<800 and dis>500 and y==0 and my_act<=10 and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("7hj>9hs");
		key_event2(ACT_D,u_back);
		wait(15)
		key_event2(ACT_D,u_front);
		wait(20)
		if dis2>200 and dis_y>100 and is_dir_front==true then
			key_on(ACT_C);
			key_on(ACT_DOWN);
			for i=1,20 do
				yield()
				if not(dis2>200 and dis_y>100 and is_dir_front==true) then
					break
				end
			end
		end
--8hj>9D>J2Ch
	elseif dis<1000 and dis>700 and y==0 and my_act<=10 and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("8hj>9hs");
		key_event2(ACT_D,ACT_UP);
		wait(15)
		key_event2(ACT_D,u_front);
		wait(20)
		if dis2>200 and dis_y>100 and is_dir_front==true then
			key_on(ACT_C);
			key_on(ACT_DOWN);
			for i=1,20 do
				yield()
				if not(dis2>200 and dis_y>100 and is_dir_front==true) then
					break
				end
			end
		end
--9hj>9D>J2Ch
	elseif dis<1280 and dis>900 and y==0 and my_act<=10 and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("9hj>9hs");
		key_event2(ACT_D,u_front);
		wait(15)
		key_event2(ACT_D,u_front);
		wait(20)
		if dis2>200 and dis_y>100 and is_dir_front==true then
			key_on(ACT_C);
			key_on(ACT_DOWN);
			for i=1,20 do
				yield()
				if not(dis2>200 and dis_y>100 and is_dir_front==true) then
					break
				end
			end
		end
--]]
--中距離以上からの８ｈｊ
	elseif move_8hjattakeovermidrange_condi()==true then
		print("中距離以上で８ＨＪ");
		key_event2(ACT_D,ACT_UP);
--中距離からのダッシュ
	elseif move_6dattakeovermidrange_condi()==true then
		print("ダッシュ接近");
		key_event2(ACT_D,front);
--低空飛翔で接近
	elseif move_approachbylowflaying_condi()==true then
		move_approachbylowflaying_exe()
--８８３飛翔
	elseif move_approachby883d_condi()==true then
		move_approachby883d_exe()
--▼ 終端運動
--▼ 相手上空へ飛び上がった際の処理
	elseif move_attakeoverhead_condi()==true then
		move_attakeoverhead_exe()
--▼ 終端機動
	--▼ 対台風時
	elseif move_terminationtaihu_condi()==true then
		move_terminationtaihu_exe()
	--▼ 終端機動1
	--台風じゃない時だが…
	elseif move_termination1_condi()==true then
		move_termination1_exe()
	--▼ 終端機動2
	--ただ動く事で自律性を錯覚させる事が目的の機動。静止やラインの設定に大きな根拠はない。
	--霊力が一定の評価を下回った場合、実行しない。
	elseif move_termination2_condi()==true then
		move_termination2_exe()
	end
	
	yield()
end
end